#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

//FArrayBSCԱ
//صַ
//http://go6.163.com/edyfox/ef/8th/pages/tiptrick/file4.zip
#include "/BSC/FArray.h"

double determinate(FArray<FArray<double> > &Lists)
{
    unsigned int *nPNum=new unsigned int[Lists.GetCount()];
    double fResult=0;
    bool bFinished=false;

    unsigned int nTemp;
    for(nTemp=0; nTemp<Lists.GetCount(); nPNum[nTemp]=nTemp++);

    do
    {
        double fLResult=1.0;

        for(unsigned int x=0; x<Lists.GetCount(); x++)
        {
            for(unsigned int y=x+1; y<Lists.GetCount(); y++)
            {
                if(nPNum[x]>nPNum[y])
                    fLResult*=-1.0;
            }
        }


        for(x=0; x<Lists.GetCount(); x++)
            fLResult=fLResult*Lists[x][nPNum[x]];

        fResult=fResult+fLResult;

        for(int i=Lists.GetCount()-1; i>0; i--)
        {
            if(nPNum[i-1]<nPNum[i])
                break;
        }

        if(!(bFinished=(i==0)))
        {
            unsigned int nMin=Lists.GetCount(); unsigned int nMinCount=i;

            for(unsigned int j=i; j<Lists.GetCount(); j++)
            {
                if(nPNum[j]>nPNum[i-1]&&nPNum[j]<nMin)
                {
                    nMin=nPNum[j];
                    nMinCount=j;
                }
            }

            nPNum[nMinCount]=nPNum[i-1];
            nPNum[i-1]=nMin;

            for(unsigned int x=i; x<Lists.GetCount()-1; x++)
            {
                unsigned int nMin=nPNum[x];
                unsigned int nMinCount=x;

                for(unsigned int y=x+1; y<Lists.GetCount(); y++)
                {
                    if(nPNum[y]<nMin)
                    {
                        nMin=nPNum[y];
                        nMinCount=y;
                    }
                }

                if(nMinCount!=x)
                {
                    nPNum[nMinCount]=nPNum[x];
                    nPNum[x]=nMin;
                }
            }
        }
    }
    while(!bFinished);

    return fResult;
}

FArray<FArray<double> > InverseMatrix(FArray<FArray<double> > &Matrix)
{
    FArray<FArray<double> > toReturn;
    FArray<FArray<double> > temp;

    double fDeterVal=determinate(Matrix);
    if(fDeterVal==0.0)return toReturn;

    for(unsigned int y=0; y<Matrix.GetCount(); y++)
    {
        toReturn.AddEmpty();

        for(unsigned int x=0; x<Matrix.GetCount(); x++)
        {
            for(unsigned int cy=0; cy<Matrix.GetCount(); cy++)
            {
                if(cy==y)continue;

                temp.AddEmpty();
                for(unsigned int cx=0; cx<Matrix.GetCount(); cx++)
                {
                    if(cx==x)continue;
                    temp[temp.GetCount()-1].Add(Matrix[cx][cy]);
                }
            }

            double fAdjointNum=determinate(temp)/fDeterVal;
            if((x+y)%2!=0)fAdjointNum*=-1;
            toReturn[y].Add(fAdjointNum);

            temp.Clear();
        }
    }

    return toReturn;
}

int main(void)
{
    int nCount;
    char sBuffer[1024];

    printf("Number of rows: ");
    gets(sBuffer);
    nCount=atoi(sBuffer);

    if(nCount<1)return 1;

    FArray<FArray<double> > fData;
    int nRow, nCol;

    for(nRow=0; nRow<nCount; nRow++)
    {
        fData.AddEmpty();

        for(nCol=0; nCol<nCount; nCol++)
        {
            printf("Row%5i Col%5i Data = ", nRow+1, nCol+1);
            gets(sBuffer);
            double temp=atof(sBuffer);
            fData[nRow].Add(temp);
        }
    }

    printf("\nThe result is:\n");
    FArray<FArray<double> > result=InverseMatrix(fData);

    if(result.GetCount()==0)
        printf("Noninvertital!!!\n");
    else
    {
        for(int y=0; y<nCount; y++)
        {
            printf("|  ");
            for(int x=0; x<nCount; x++)
                printf("%5g", result[y][x]);

            printf("  |\n");
        }
    }

    getch();

    return 0;
}
